(* file BCN_SIF_preauto_trad.ml *)
(* with S B C N K I and S_IF combinators *)
(* skip the lambda distribution only when no application in a branch (BCN) *)
(* partial applications of combinators are done automatically *)


open Term ;;
let _ = print_endline "BCN_SIF_preauto" ;;

(* ---------------------   combinators  ---------------------------- *)

(* combinators S, K and I *)


let cI = P_Const (V_Fun (fun x -> x)) 
and cK = P_Const (V_Fun (fun c -> V_Fun (fun _ -> c)) )
and cS = P_Const (V_Fun ( 
  fun (V_Fun f) -> V_Fun (
    fun (V_Fun g) -> V_Fun ( 
      fun x -> match (f x) with     (* 1 caml capplication *) 
          V_Fun h -> h (g x)     )))) (* 2 caml applications *) 
;;

(* combinator S_IF *)

(*let cSIF =  P_Const (V_Fun (fun (V_Fun e1) -> 
                       V_Fun (fun (V_Fun e2) ->
                                            V_Fun (fun (V_Fun e3) ->
                                                     V_Fun (fun x ->
  match e1 x with (* caml application *)
      V_Bool true  -> e2 x  (* caml application *)
    | V_Bool false -> e3 x  (* caml application *)
    | _ -> raise TypeError                        )))))
;;*)

 let cSIF =  P_Const (V_Fun (fun (V_Fun e_if) ->
			      V_Fun (fun e_then ->
                                       V_Fun (fun e_else ->
						V_Fun (fun x ->
							 let branch = (
							   match e_if x with (* caml application *)
							     | V_Bool true -> e_then
							     | V_Bool false -> e_else
							     | _ -> raise TypeError
							 ) in  (match  branch with V_Fun f -> f) x 
						      )
					     )
				    )
			   )
		    )
  

(* combinators B C N *)

let cYN = P_Const (V_Fun (fun (V_Fun f) ->
		       V_Fun (fun e ->
				 V_Fun ( fun x ->
					   match  (f x) with V_Fun (h) -> (* caml application *)
					   h e ))));;                      (* caml application *)

let cNY = P_Const (V_Fun (fun (V_Fun f) ->
		       V_Fun (fun (V_Fun (g)) ->
				 V_Fun ( fun x -> f (g x) ))));; (* 2 caml applications *)

let cNN =  P_Const (V_Fun (fun (V_Fun f) ->
		       V_Fun (fun e ->
				 V_Fun ( fun _ ->
					   f e)))) ;; (* caml application *)
(*let cYY = cS ;;*)


(* ----------------------------------------------------------------- *)



let rec skip x = function
  | P_Const _ -> true
  | P_Var y -> x <> y  (*false*) (* vérifier *) (* la version x<>y donne de meilleurs résultats mais est-elle correcte? *)
  | P_App (e1, e2) -> false
  | P_Abs (y, e) -> x=y || not (free x e) ;;



(* condition d'utilisation de pre_eval_app :
   on a une application d'un combinateur. *)
  
let rec pre_eval_app e = match e with
  | P_App (e1,e2) ->
      ( match (pre_eval_app e1, pre_eval_app e2) 
	with 
	  | (P_Const (V_Fun f),P_Const v) -> P_Const (f v)
	  | (e'1,e'2) -> P_App (e'1,e'2)
      )
  | _ -> e
      


let rec elim = function

  | P_Const c -> P_Const c
  | P_Var x    -> P_Var x

  | P_App (e1, e2) ->  P_App (elim e1, elim e2) 


(* -- Case -- K *)
  | P_Abs(s, P_Var s' ) -> 
      if s = s' 
      then  cI 
      else  (P_App (cK, P_Var s'))

  | P_Abs(_,P_Const c) -> P_Const (V_Fun (fun _ -> c)) (* hand-made pre-eval *)

 (* case S_IF *)
  | P_Abs(s,P_App(P_App(P_App(i,e1), P_Abs(_,e2)), P_Abs(_,e3))) when i  == Purify.cIF ->

    pre_eval_app(  P_App (P_App (P_App (cSIF , elim (P_Abs (s,e1))), elim (P_Abs(s,e2))), elim (P_Abs (s, e3))))
	(* see my PhD thesis page 116/117 *)











(* B_IF and C_IF and N_IF may be nice too *)



(* case B, C, N, S *) 
  | P_Abs(s,P_App(e1,e2)) ->
      (match (skip s e1,skip s e2) with
	 | true,  true  -> pre_eval_app( P_App(P_App(cNN, elim e1)           , elim e2)            )
	 | true,  false -> pre_eval_app( P_App(P_App(cNY, elim e1)           , elim (P_Abs(s,e2))) )
	 | false, true  -> pre_eval_app( P_App(P_App(cYN, elim (P_Abs(s,e1))), elim e2)            )
	 | false, false -> pre_eval_app( P_App(P_App(cS , elim (P_Abs(s,e1))), elim (P_Abs(s,e2))) )
      )

  | P_Abs(s, (P_Abs(_,_) as t))->
      
       elim (P_Abs(s,elim t))

  ;;

let trans e = check_no_var (elim e) ;;
