(* file BCNtrad.ml *)
(* with S B C N K I combinators *)
(* skip the lambda distribution only when no application in a branch *)

open Term ;;
open Combinators ;;


let rec skip x = function
  | P_Int _ -> true
  | P_Bool _ -> true
  | P_ExtFun _ -> true
  | P_Var y -> x <> y  (*false*) (* vérifier *) (* la version x<>y donne de meilleurs résultats mais est-elle correcte? *)
  | P_App (e1, e2) -> false
  | P_Abs (y, e) -> x=y || not (free x e) ;; 



let rec bcn  = 
function
    P_Int i    -> P_Int i
  | P_Bool b   -> P_Bool b 
  | P_Var x    -> P_Var x
  | P_ExtFun f -> P_ExtFun f   

  | P_App (e1, e2) ->  P_App (bcn e1, bcn e2) 
      
  | P_Abs(s, P_Var s' ) -> 
      if s = s' 
      then  cI 
      else  (P_App (cK, P_Var s'))

  | P_Abs(_, P_Int i   ) -> P_App (cK, P_Int i ) 
  | P_Abs(_, P_Bool b  ) -> P_App (cK, P_Bool b)
  | P_Abs(_, P_ExtFun f) -> P_App (cK, P_ExtFun f )

  | P_Abs(s,P_App(e1,e2)) ->
      (match (skip s e1,skip s e2) with
	 | true,  true  -> P_App(P_App(cNN, bcn e1)           , bcn e2)
	 | true,  false -> P_App(P_App(cNY, bcn e1)           , bcn (P_Abs(s,e2)))
	 | false, true  -> P_App(P_App(cYN, bcn (P_Abs(s,e1))), bcn e2)
	 | false, false -> P_App(P_App(cYY, bcn (P_Abs(s,e1))), bcn (P_Abs(s,e2)))
      )
	
  | P_Abs(s, (P_Abs(_,_) as t))->  bcn (P_Abs(s,bcn t))

  ;;

let trans e = check_no_var (bcn e) ;;
