(* file SKI_SIF_trad.ml *)
(* with combinators S K I and S_IF *)
open Term ;;


(* ---------------------   combinators  ---------------------------- *)

(* combinators S, K and I *)


let cI = P_Const (V_Fun (fun x -> x)) 
and cK = P_Const (V_Fun (fun c -> V_Fun (fun _ -> c)) )
and cS = P_Const (V_Fun ( 
  fun (V_Fun f) -> V_Fun (
    fun (V_Fun g) -> V_Fun ( 
      fun x -> match (f x) with     (* 1 caml capplication *) 
          V_Fun h -> h (g x)     )))) (* 2 caml applications *) 
;;

(* combinator S_IF *)

let cSIF =  P_Const (V_Fun (fun (V_Fun e1) -> 
                       V_Fun (fun (V_Fun e2) ->
                                            V_Fun (fun (V_Fun e3) ->
                                                     V_Fun (fun x ->
  match e1 x with (* caml application *)
      V_Bool true  -> e2 x  (* caml application *)
    | V_Bool false -> e3 x  (* caml application *)
    | _ -> raise TypeError                        )))))
;;

(* ------------------------ variable elimination ------------------ *)

let rec elim = function
(*    P_Int i    -> P_Int i
  | P_Bool b   -> P_Bool b  *)
  | P_Const c -> P_Const c
  | P_Var x    -> P_Var x
(*  | P_ExtFun f -> P_ExtFun f   *)

  | P_App (e1, e2) ->  P_App (elim e1, elim e2) 
     

(* -- Case -- K *)
  | P_Abs(s, P_Var s' ) -> 
      if s = s' 
      then  cI 
      else  (P_App (cK, P_Var s'))

(*  | P_Abs(_, P_Int i   ) -> P_App (cK, P_Int i ) 
  | P_Abs(_, P_Bool b  ) -> P_App (cK, P_Bool b)
  | P_Abs(_, P_ExtFun f) -> P_App (cK, P_ExtFun f ) *)
  | P_Abs(_, P_Const c) -> P_App (cK, P_Const c )

(* case S_IF *)
  | P_Abs(s,P_App(P_App(P_App(i,e1), P_Abs(_,e2)), P_Abs(_,e3))) when i  == Purify.cIF ->
      P_App (P_App (P_App (cSIF, elim (P_Abs (s,e1))), elim (P_Abs(s,e2))), elim (P_Abs (s, e3)))
	(* see my PhD page 116/117 *)


  | P_Abs(s,P_App(e1,e2)) ->
       P_App(P_App(cS, elim (P_Abs(s,e1))), elim (P_Abs(s,e2)))
      
  | P_Abs(s, (P_Abs(_,_) as t))->
      
       elim (P_Abs(s,elim t))

  ;;

let trans e = check_no_var (elim e) ;;
