(* ************************************************* *)
(* S K I translation                                 *)
(* ************************************************* *)

open Term ;;


(* ---------------------   combinators  ---------------------------- *)

(* combinators S, K and I *)


let cI = P_Const (V_Fun (fun x -> x)) 
and cK = P_Const (V_Fun (fun c -> V_Fun (fun _ -> c)) )
and cS = P_Const (V_Fun ( 
  fun (V_Fun f) -> V_Fun (
    fun (V_Fun g) -> V_Fun ( 
      fun x -> match (f x) with       (* 1 caml capplication *) 
          V_Fun h -> h (g x)     )))) (* 2 caml applications *) 
;;

(* ------------------------ variable elimination ------------------ *)


(* the type cannot change since ski is applied to its result *)
let rec elim = function
    P_Const c    -> P_Const c
  | P_Var x      -> P_Var x

  | P_App (e1, e2) ->  P_App (elim e1, elim e2) 
      
  | P_Abs(s, P_Var s' ) -> 
      if s = s' 
      then  cI 
      else  (P_App (cK, P_Var s'))

  | P_Abs(_, P_Const c) -> P_App (cK, P_Const c )

  | P_Abs(s,P_App(e1,e2)) ->
       P_App(P_App(cS, elim (P_Abs(s,e1))), elim (P_Abs(s,e2)))
      
  | P_Abs(s, (P_Abs(_,_) as t))->  elim (P_Abs(s,elim t))

  ;;

let trans e = check_no_var (elim e) ;;

