(* file SKItrad2.ml *)
(* partial applications of combinator K are done *)

open Term ;;
open Combinators ;;



let rec ski = function
    P_Int i    -> P_Int i
  | P_Bool b   -> P_Bool b 
  | P_Var x    -> P_Var x
  | P_ExtFun f -> P_ExtFun f   

  | P_App (e1, e2) ->  P_App (ski e1, ski e2) 
      
  | P_Abs(s, P_Var s' ) -> 
      if s = s' 
      then  cI 
      else  (P_App (cK, P_Var s'))

  | P_Abs(_, P_Int i   ) -> P_ExtFun (fun _ -> V_Int i) 
  | P_Abs(_, P_Bool b  ) -> P_ExtFun (fun _ -> V_Bool b)
  | P_Abs(_, P_ExtFun f) -> P_ExtFun (fun _ -> V_Fun f)
 
  | P_Abs(s,P_App(e1,e2)) ->
       P_App(P_App(cS, ski (P_Abs(s,e1))), ski (P_Abs(s,e2)))
      
  | P_Abs(s, (P_Abs(_,_) as t))->
      
       ski (P_Abs(s,ski t))

  ;;


let trans e = check_no_var (ski e) ;;
