 {
        open Parser        (* The type token is defined in parser.mli *)
        exception Eof
        }
        rule token = parse
            [' ' '\t']     { token lexbuf }     (* skip blanks *)
          | ['\n' ]        { token lexbuf }
          | ['0'-'9']+ as lxm { INT(int_of_string lxm) }
	  | ['a'-'z']+ as lxm { match lxm with 
				  | "if"   -> IF 
				  | "then" -> THEN
				  | "else" -> ELSE
				  | "fi"   -> FI
				  | "let"  -> LET
				  | "in"   -> IN

				  | _ -> IDENT(lxm) }
          | '+'            { PLUS } 
          | '-'            { MINUS }
          | '*'            { TIMES }
          | '/'            { DIV }
          | '('            { LPAREN }
          | ')'            { RPAREN }
	  | '{'            { LACC }
	  | '}'            { RACC }
	  | '\\'           { LAMBDA  } (* backslash *)
	  | '.'            { DOT    }
	  | ":="           { SET    }
	  | '!'            { GET    }
	  | "<="           { INF    }
	  | '='            { BE }
          | ','            { CONS }
	  | ';'            { SEQUENCE }
	  | eof            { EOF }
	  
