#!/bin/bash

if [ $# -ne 2 ]
then
	echo "You must specify an executable interpreter and a file containing a list of programs to interpret"
	exit 1
fi


listfichiers=`cat $2`

echo " "
echo "Timing $1 on $listfichiers"
echo " "

for f in $listfichiers
do
    echo "Timing $1 on $f"
    /usr/bin/time -f " command : %C\n real : %e\n system : %S\n user : %U\n percentage of CPU : %P\n max resident memory (Kbytes) : %M\n number of swaps out : %W\n number of context switch : %c\n" $1 < $f > /dev/null
    echo " "
done
